#pragma once
#include <iostream>
#include <vector>
// GLEW
#define GLEW_STATIC
#include <GL/glew.h>
// GLFW
#include <GLFW/glfw3.h>
//GLM
#include <glm/glm.hpp>
#include <glm/gtc/matrix_transform.hpp>
#include <glm/gtc/type_ptr.hpp>
//Shader
#include "Shader.h"
//matematics for modeling
#include "Satellite.h"



enum axis {_OX, _OY, _OZ};

void key_callback(GLFWwindow* window, int key, int scancode, int action, int mode);

void coord_axis(GLuint& VAO, axis i_axis);

void draw_coord_axis(GLuint& VAO);

void modulation(Satellite& sat, double step_time, double end, std::vector<GLfloat>& DCS, std::vector<GLfloat>& DVS);

void scaling(std::vector<GLfloat>& DS, GLfloat& max);

void draw_modulation(std::vector<GLfloat>& DCS, std::vector<GLfloat>& DVS, GLfloat& max, Shader& _shader);