﻿#include "Planets.h"
#include <sstream>

int Moon::calculate_s() {
	m_s.at(0) = sin(1.24614 + 0.35255 * m_ts);
	m_s.at(1) = sin(1.75106 + 0.28325 * m_ts);
	m_s.at(2) = sin(1.05727 - 2.31868 * m_ts);
	m_s.at(3) = sin(2.18240 - 33.7571 * m_ts);
	m_s.at(4) = sin(0.65961 - 33.79719 * m_ts);
	m_s.at(5) = sin(2.68173 - 2.62983 * m_ts);
	m_s.at(6) = sin(0.93890 - 33.77281 * m_ts);
	return 0;
};

int Moon::calculate_r() {
	calculate_s();
	m_r.at(0) = 0.84 * m_s.at(0) + 0.31 * m_s.at(1) + 14.27 * m_s.at(2) + 7.26 * m_s.at(3) + 0.28 * m_s.at(4) + 0.24 * m_s.at(5);
	m_r.at(1) = 2.94 * m_s.at(0) + 0.31 * m_s.at(1) + 14.27 * m_s.at(2) + 9.34 * m_s.at(3) + 1.12 * m_s.at(4) + 0.83 * m_s.at(5);
	m_r.at(2) = -6.4 * m_s.at(0) - 1.89 * m_s.at(5);
	m_r.at(3) = 0.21 * m_s.at(0) + 0.31 * m_s.at(1) + 14.27 * m_s.at(2) - 88.7 * m_s.at(3) - 15.3 * m_s.at(4) + 0.24 * m_s.at(5) - 1.86 * m_s.at(6);
	m_r.at(4) = 7.24 * m_s.at(0) + 0.31 * m_s.at(1) + 14.27 * m_s.at(2) + 7.26 * m_s.at(3) + 0.28 * m_s.at(4) + 2.13 * m_s.at(5);
	return 0;
}

int Moon::calculate_sin_πс()
{
	m_sin_πс = +3422.7 + 0.260968 * cos(4 * m_cfa.D) + 28.233869 * cos(2 * m_cfa.D) + 0.043566 * cos(m_cfa.l + 4 * m_cfa.D)
		+ 3.08589 * cos(m_cfa.l + 2 * m_cfa.D) + 186.539296 * cos(m_cfa.l) + 34.311569 * cos(m_cfa.l - 2 * m_cfa.D)
		+ 0.60071 * cos(m_cfa.l - 4 * m_cfa.D) - 0.300334 * cos(m_cfa.L + 2 * m_cfa.D) - 0.399822 * cos(m_cfa.L)
		+ 1.916735 * cos(m_cfa.L - 2 * m_cfa.D) + 0.034671 * cos(m_cfa.L - 4 * m_cfa.D) - 0.977818 * cos(m_cfa.D)
		+ 0.282799 * cos(2 * m_cfa.l + 2 * m_cfa.D) + 10.165933 * cos(2 * m_cfa.l) - 0.304041 * cos(2 * m_cfa.l - 2 * m_cfa.D)
		+ 0.372337 * cos(2 * m_cfa.l - 4 * m_cfa.D) - 0.949147 * cos(m_cfa.l + m_cfa.L) + 1.443617 * cos(m_cfa.l + m_cfa.L - 2 * m_cfa.D)
		+ 0.067283 * cos(m_cfa.l + m_cfa.L - 4 * m_cfa.D) + 0.229935 * cos(m_cfa.l - m_cfa.L + 2 * m_cfa.D) + 1.152852 * cos(m_cfa.l - m_cfa.L)
		- 0.225821 * cos(m_cfa.l - m_cfa.L - 2 * m_cfa.D) - 0.008639 * cos(2 * m_cfa.L) + 0.091646 * cos(2 * m_cfa.L - 2 * m_cfa.D)
		- 0.012103 * cos(2 * m_cfa.F) - 0.105291 * cos(2 * m_cfa.F - 2 * m_cfa.D) - 0.109456 * cos(m_cfa.l + m_cfa.D)
		+ 0.011715 * cos(m_cfa.l - m_cfa.D) - 0.038258 * cos(m_cfa.l - 3 * m_cfa.D) + 0.149444 * cos(m_cfa.L + m_cfa.D)
		- 0.118714 * cos(3 * m_cfa.l - 2 * m_cfa.D) - 0.047853 * cos(m_cfa.l - 2 * m_cfa.F + 2 * m_cfa.D)
		- 0.708093 * cos(m_cfa.l - 2 * m_cfa.F) - 0.048117 * cos(m_cfa.l + m_cfa.L + 2 * m_cfa.D)
		+ 0.621546 * cos(3 * m_cfa.l) - 0.103337 * cos(2 * m_cfa.l + m_cfa.L) - 0.083228 * cos(m_cfa.l + 2 * m_cfa.F - 2 * m_cfa.D);
	return 0;
}

int Moon::calculate_Δλ_c()
{
	m_Δλ_c = +13.90 * sin(4 * m_cfa.D) + 2369.92 * sin(2 * m_cfa.D) + 1.98 * sin(m_cfa.l + 4 * m_cfa.D) + 191.96 * sin(m_cfa.l + 2 * m_cfa.D)
		- 4586.47 * sin(m_cfa.l - 2 * m_cfa.D) - 38.43 * sin(m_cfa.l - 4 * m_cfa.D) - 24.42 * sin(m_cfa.L + 2 * m_cfa.D) - 668.15 * sin(m_cfa.L)
		- 165.15 * sin(m_cfa.L - 2 * m_cfa.D) - 1.88 * sin(m_cfa.L - 4 * m_cfa.D) - 125.15 * sin(m_cfa.D) + 14.38 * sin(2 * m_cfa.l + 2 * m_cfa.D)
		+ 769.02 * sin(2 * m_cfa.l) - 211.66 * sin(2 * m_cfa.l - 2 * m_cfa.D) - 30.77 * sin(2 * m_cfa.l - 4 * m_cfa.D)
		- 2.92 * sin(m_cfa.l + m_cfa.L + 2 * m_cfa.D) - 109.67 * sin(m_cfa.l + m_cfa.L) - 205.96 * sin(m_cfa.l + m_cfa.L - 2 * m_cfa.D)
		- 4.39 * sin(m_cfa.l + m_cfa.L - 4 * m_cfa.D) + 14.57 * sin(m_cfa.l - m_cfa.L + 2 * m_cfa.D) + 147.69 * sin(m_cfa.l - m_cfa.L)
		+ 28.47 * sin(m_cfa.l - m_cfa.L - 2 * m_cfa.D) - 7.49 * sin(2 * m_cfa.L) - 8.09 * sin(2 * m_cfa.L - 2 * m_cfa.D) - 5.74 * sin(2 * m_cfa.F + 2 * m_cfa.D)
		- 411.60 * sin(2 * m_cfa.F) - 55.17 * sin(2 * m_cfa.F - 2 * m_cfa.D) - 8.46 * sin(m_cfa.l + m_cfa.D) + 18.61 * sin(m_cfa.l - m_cfa.D)
		+ 3.21 * sin(m_cfa.l - 3 * m_cfa.D) + 18.02 * sin(m_cfa.L + m_cfa.D) + 0.56 * sin(m_cfa.L - m_cfa.D) + 36.12 * sin(3 * m_cfa.l)
		- 13.19 * sin(3 * m_cfa.l - 2 * m_cfa.D) - 7.65 * sin(2 * m_cfa.l + m_cfa.L) + 9.70 * sin(2 * m_cfa.l - m_cfa.L)
		- 2.49 * sin(2 * m_cfa.l - m_cfa.L - 2 * m_cfa.D) - 0.99 * sin(m_cfa.l + 2 * m_cfa.F + 2 * m_cfa.D) - 45.10 * sin(m_cfa.l + 2 * m_cfa.F)
		- 6.38 * sin(m_cfa.l - 2 * m_cfa.F + 2 * m_cfa.D) + 39.53 * sin(m_cfa.l - 2 * m_cfa.F) + 1.75 * sin(2 * m_cfa.l - m_cfa.D)
		+ 22639.50 * sin(m_cfa.l) - 0.57 * sin(2 * m_cfa.l - 6 * m_cfa.D) + 0.64 * sin(m_cfa.l - m_cfa.L - 4 * m_cfa.D)
		+ 1.06 * sin(3 * m_cfa.l + 2 * m_cfa.D) - 1.19 * sin(3 * m_cfa.l - 4 * m_cfa.D) - 8.63 * sin(2 * m_cfa.l + m_cfa.L - 2 * m_cfa.D)
		- 2.74 * sin(2 * m_cfa.l + m_cfa.L - 4 * m_cfa.D) + 1.18 * sin(2 * m_cfa.l - m_cfa.L + 2 * m_cfa.D) - 1.17 * sin(m_cfa.l + 2 * m_cfa.L)
		- 7.41 * sin(m_cfa.l + 2 * m_cfa.L - 2 * m_cfa.D) + 0.76 * sin(m_cfa.l - 2 * m_cfa.L + 2 * m_cfa.D) + 2.58 * sin(m_cfa.l - 2 * m_cfa.L)
		+ 2.53 * sin(m_cfa.l - 2 * m_cfa.L - 2 * m_cfa.D) + 9.37 * sin(m_cfa.l - 2 * m_cfa.F - 2 * m_cfa.D)
		- 2.15 * sin(m_cfa.L + 2 * m_cfa.F - 2 * m_cfa.D) - 1.44 * sin(m_cfa.L - 2 * m_cfa.F + 2 * m_cfa.D) - 0.59 * sin(2 * m_cfa.l + m_cfa.D)
		+ 1.22 * sin(2 * m_cfa.l - 3 * m_cfa.D) + 1.27 * sin(m_cfa.l + m_cfa.L + m_cfa.D) - 1.09 * sin(m_cfa.l - m_cfa.L - m_cfa.D)
		+ 0.58 * sin(2 * m_cfa.F - m_cfa.D) + 1.94 * sin(4 * m_cfa.l) - 0.95 * sin(4 * m_cfa.l - 2 * m_cfa.D) - 0.55 * sin(3 * m_cfa.l + m_cfa.L)
		+ 0.67 * sin(3 * m_cfa.l - m_cfa.L) - 4.00 * sin(2 * m_cfa.l + 2 * m_cfa.F) + 0.56 * sin(2 * m_cfa.l + 2 * m_cfa.F - 2 * m_cfa.D)
		- 1.30 * sin(2 * m_cfa.l - 2 * m_cfa.F) + 0.54 * sin(2 * m_cfa.l - 2 * m_cfa.F - 2 * m_cfa.D);
	return 0;
}

int Moon::calculate_β()
{
	m_β = +117.26 * sin(m_cfa.F + 2 * m_cfa.D) + 18461.35 * sin(m_cfa.F) - 623.66 * sin(m_cfa.F - 2 * m_cfa.D) - 3.67 * sin(m_cfa.F - 4 * m_cfa.D)
		+ 15.12 * sin(m_cfa.l + m_cfa.F + 2 * m_cfa.D) - 166.58 * sin(m_cfa.l + m_cfa.F - 2 * m_cfa.D) - 6.58 * sin(m_cfa.l + m_cfa.F - 4 * m_cfa.D)
		+ 3.00 * sin(-m_cfa.l + m_cfa.F + 4 * m_cfa.D) + 199.49 * sin(-m_cfa.l + m_cfa.F + 2 * m_cfa.D) - 999.69 * sin(-m_cfa.l + m_cfa.F)
		- 33.36 * sin(-m_cfa.l + m_cfa.F - 2 * m_cfa.D) - 6.48 * sin(m_cfa.L + m_cfa.F) - 29.65 * sin(m_cfa.L + m_cfa.F - 2 * m_cfa.D)
		+ 7.98 * sin(-m_cfa.L + m_cfa.F + 2 * m_cfa.D) + 4.86 * sin(-m_cfa.L + m_cfa.F) - 5.38 * sin(m_cfa.F + m_cfa.D) + 4.81 * sin(m_cfa.F - m_cfa.D)
		- 15.57 * sin(2 * m_cfa.l + m_cfa.F - 2 * m_cfa.D) - 31.76 * sin(-2 * m_cfa.l + m_cfa.F) - 5.33 * sin(m_cfa.l + m_cfa.L + m_cfa.F)
		+ 8.89 * sin(-m_cfa.l - m_cfa.L + m_cfa.F + 2 * m_cfa.D) + 6.75 * sin(m_cfa.l - m_cfa.L + m_cfa.F) - 5.65 * sin(-m_cfa.l + m_cfa.L + m_cfa.F)
		- 1.02 * sin(m_cfa.l + 3 * m_cfa.F) + 1.19 * sin(m_cfa.F + 4 * m_cfa.D) + 1010.16 * sin(m_cfa.l + m_cfa.F) - 1.26 * sin(m_cfa.L + m_cfa.F + 2 * m_cfa.D)
		+ 12.12 * sin(-m_cfa.L + m_cfa.F - 2 * m_cfa.D) - 6.29 * sin(3 * m_cfa.F) - 2.18 * sin(3 * m_cfa.F - 2 * m_cfa.D)
		+ 1.51 * sin(2 * m_cfa.l + m_cfa.F + 2 * m_cfa.D) + 61.91 * sin(2 * m_cfa.l + m_cfa.F) + 2.41 * sin(-2 * m_cfa.l + m_cfa.F + 4 * m_cfa.D)
		- 1.62 * sin(-2 * m_cfa.l + m_cfa.F + 2 * m_cfa.D) - 2.14 * sin(-2 * m_cfa.l + m_cfa.F - 2 * m_cfa.D)
		- 7.45 * sin(m_cfa.l + m_cfa.L + m_cfa.F - 2 * m_cfa.D) + 5.08 * sin(-m_cfa.l - m_cfa.L + m_cfa.F)
		+ 1.13 * sin(m_cfa.l - m_cfa.L + m_cfa.F + 2 * m_cfa.D) - 1.32 * sin(-m_cfa.l + m_cfa.L + m_cfa.F + 2 * m_cfa.D)
		- 1.77 * sin(-m_cfa.l + m_cfa.L + m_cfa.F - 2 * m_cfa.D) - 1.09 * sin(2 * m_cfa.L + m_cfa.F - 2 * m_cfa.D)
		- 2.79 * sin(-m_cfa.l + 3 * m_cfa.F) + 3.98 * sin(3 * m_cfa.l + m_cfa.F) - 1.51 * sin(3 * m_cfa.l + m_cfa.F - 2 * m_cfa.D)
		- 1.58 * sin(-3 * m_cfa.l + m_cfa.F);
	return 0;
}

int Moon::calculateGEC(double input_MJD)
{
	recalc(_MJDt.convert_MJD_to_TDB(input_MJD));
	calculateСorrecteFundamentalArg();
	calculate_Δλ_c();
	calculate_β();
	calculate_sin_πс();
	m_GEC(0, 0) = m_cfa.λ + RS * m_Δλ_c;
	m_GEC(1, 0) = RS * m_β;
	m_GEC(2, 0) = m_scalefactor * (1 / (RS * m_sin_πс));
	calculateDC();
	return 0;
}

int Moon::calculateСorrecteFundamentalArg() {
	calculate_r();
	m_cfa.λ = m_fa.λ + RS * m_r.at(0);
	m_cfa.l = m_fa.l + RS * m_r.at(1);
	m_cfa.L = m_fa.L + RS * m_r.at(2);
	m_cfa.F = m_fa.F + RS * m_r.at(3);
	m_cfa.D = m_fa.D + RS * m_r.at(4);
	return 0;
}

int Moon::calculateRm()
{
	m_Rm = sqrt(pow(m_DC(0, 0), 2) + pow(m_DC(1, 0), 2) + pow(m_DC(2, 0), 2));
	return 0;
}

int Moon::calculateRo(const Matrix& DC_coord_object)
{
	m_Ro = sqrt(pow(m_DC(0, 0) - DC_coord_object(0, 0), 2) +
		pow(m_DC(1, 0) - DC_coord_object(1, 0), 2) +
		pow(m_DC(2, 0), 2) - DC_coord_object(2, 0));
	return 0;
}

Matrix Moon::calculateFm(const Matrix& DC_coord_object, double input_MJD)
{
	calculateGEC(input_MJD);
	calculateRm();
	calculateRo(DC_coord_object);
	m_F(0, 0) = gravitational_parameter_Moon * (((m_DC(0, 0) - DC_coord_object(0, 0)) / pow(m_Ro, 3)) - (m_DC(0, 0) / pow(m_Rm, 3)));
	m_F(1, 0) = gravitational_parameter_Moon * (((m_DC(1, 0) - DC_coord_object(1, 0)) / pow(m_Ro, 3)) - (m_DC(1, 0) / pow(m_Rm, 3)));
	m_F(2, 0) = gravitational_parameter_Moon * (((m_DC(2, 0) - DC_coord_object(2, 0)) / pow(m_Ro, 3)) - (m_DC(2, 0) / pow(m_Rm, 3)));
	return m_F;
}

//std::ostream& operator<<(std::ostream& out, Moon& i_moon)
//{
//	out << "\n******************************************"
//		<< "\n             class Moon"
//		<< "\n******************************************"
//		<< "\nm_s = " << i_moon.m_s.at(0) << " " << i_moon.m_s.at(1) << " " << i_moon.m_s.at(2) << " "
//		<< i_moon.m_s.at(3) << " " << i_moon.m_s.at(4) << " " << i_moon.m_s.at(5) << " "
//		<< i_moon.m_s.at(6) << " "
//		<< "\nr_s = " << i_moon.m_r.at(0) << " " << i_moon.m_r.at(1) << " "
//		<< i_moon.m_r.at(2) << " " << i_moon.m_r.at(3) << " " << i_moon.m_r.at(4)
//		<< i_moon.m_cfa << "\nm_Δλ_c = " << i_moon.m_Δλ_c << "\n\nm_β = " << i_moon.m_β << "\n\nm_sin_πс = " << i_moon.m_sin_πс
//		<< "\n\nm_GEC: " << i_moon.m_GEC << "\nm_dc:" << i_moon.m_DC;
//	return out;
//}
//
//std::ofstream& operator<<(std::ofstream& out, Moon& i_moon)
//{
//	out << "\n******************************************"
//		<< "\n             class Moon"
//		<< "\n******************************************"
//		<< "\nm_s = " << i_moon.m_s.at(0) << " " << i_moon.m_s.at(1) << " " << i_moon.m_s.at(2) << " "
//		<< i_moon.m_s.at(3) << " " << i_moon.m_s.at(4) << " " << i_moon.m_s.at(5) << " "
//		<< i_moon.m_s.at(6) << " "
//		<< "\nr_s = " << i_moon.m_r.at(0) << " " << i_moon.m_r.at(1) << " "
//		<< i_moon.m_r.at(2) << " " << i_moon.m_r.at(3) << " " << i_moon.m_r.at(4)
//		<< i_moon.m_cfa << "\nm_Δλ_c = " << i_moon.m_Δλ_c << "\n\nm_β = " << i_moon.m_β << "\n\nm_sin_πс = " << i_moon.m_sin_πс
//		<< "\n\nm_GEC: " << i_moon.m_GEC << "\nm_dc:" << i_moon.m_DC;
//	return out;
//}

double Sun::DILong_V()
{
	std::vector<double> earth_c{ 2 * m_M.at(1), 3 * m_M.at(1), 4 * m_M.at(1), 5 * m_M.at(1), 6 * m_M.at(1), 7 * m_M.at(1) };
	std::vector<double>	venus_c{ 2 * m_M.at(0), 3 * m_M.at(0), 4 * m_M.at(0), 5 * m_M.at(0), 6 * m_M.at(0) };

	double output = -0.22 * cos(m_M.at(1)) + 6892.76 * sin(m_M.at(1)) + (-0.06 * cos(m_M.at(1)) - 17.35 * sin(m_M.at(1))) * m_ts
		+ (-0.01 * cos(m_M.at(1)) - 0.05 * sin(m_M.at(1)) * m_ts * m_ts) + 71.98 * sin(earth_c.at(0)) - 0.36 * sin(earth_c.at(0)) * m_ts
		+ 1.04 * sin(earth_c.at(1)) + 0.03 * cos(-m_M.at(0)) - 0.07 * sin(-m_M.at(0)) + 2.35 * cos(m_M.at(1) - m_M.at(0))
		- 4.23 * sin(m_M.at(1) - m_M.at(0)) - 0.10 * cos(m_M.at(1) - venus_c.at(0)) + 0.06 * sin(m_M.at(1) - venus_c.at(0))
		- 0.06 * cos(earth_c.at(0) - m_M.at(0)) - 0.03 * sin(earth_c.at(0) - m_M.at(0))
		- 4.70 * cos(earth_c.at(0) - venus_c.at(0)) + 2.90 * sin(earth_c.at(0) - venus_c.at(0))
		+ 1.80 * cos(earth_c.at(1) - venus_c.at(0)) - 1.74 * sin(earth_c.at(1) - venus_c.at(0))
		- 0.67 * cos(earth_c.at(1) - venus_c.at(1)) + 0.03 * sin(earth_c.at(1) - venus_c.at(1))
		+ 0.03 * cos(earth_c.at(2) - venus_c.at(0)) - 0.03 * sin(earth_c.at(2) - venus_c.at(0))
		+ 1.51 * cos(earth_c.at(2) - venus_c.at(1)) - 0.40 * sin(earth_c.at(2) - venus_c.at(1))
		- 0.19 * cos(earth_c.at(2) - venus_c.at(2)) - 0.09 * sin(earth_c.at(2) - venus_c.at(2))
		+ 0.76 * cos(earth_c.at(3) - venus_c.at(1)) - 0.68 * sin(earth_c.at(3) - venus_c.at(1))
		- 0.14 * cos(earth_c.at(3) - venus_c.at(2)) - 0.04 * sin(earth_c.at(3) - venus_c.at(2))
		- 0.05 * cos(earth_c.at(3) - venus_c.at(3)) - 0.07 * sin(earth_c.at(3) - venus_c.at(3))
		+ 0.15 * cos(earth_c.at(4) - venus_c.at(2)) - 0.04 * sin(earth_c.at(4) - venus_c.at(2))
		- 0.03 * cos(earth_c.at(4) - venus_c.at(3)) - 0.03 * sin(earth_c.at(4) - venus_c.at(3))
		- 0.04 * sin(earth_c.at(4) - venus_c.at(4))
		- 0.12 * cos(earth_c.at(5) - venus_c.at(3)) - 0.03 * sin(earth_c.at(5) - venus_c.at(3));
	return output;
}

double Sun::DILong_M()
{
	std::vector<double> earth_c{ 2 * m_M.at(1), 3 * m_M.at(1), 4 * m_M.at(1), 5 * m_M.at(1) };
	std::vector<double> mars_c{ 2 * m_M.at(2), 3 * m_M.at(2),  4 * m_M.at(2) ,5 * m_M.at(2) , 6 * m_M.at(2) , 7 * m_M.at(2), 8 * m_M.at(2) };

	double output = -0.22 * cos(m_M.at(1) - m_M.at(2)) + 0.17 * sin(m_M.at(1) - m_M.at(2))
		- 1.66 * cos(m_M.at(1) - mars_c.at(0)) + 0.62 * sin(m_M.at(1) - mars_c.at(0))
		+ 1.96 * cos(earth_c.at(0) - mars_c.at(0)) + 0.57 * sin(earth_c.at(0) - mars_c.at(0))
		+ 0.40 * cos(earth_c.at(0) - mars_c.at(1)) + 0.15 * sin(earth_c.at(0) - mars_c.at(1))
		+ 0.53 * cos(earth_c.at(0) - mars_c.at(2)) + 0.26 * sin(earth_c.at(0) - mars_c.at(2))
		+ 0.05 * cos(earth_c.at(1) - mars_c.at(1)) + 0.12 * sin(earth_c.at(1) - mars_c.at(1))
		- 0.04 * cos(earth_c.at(1) - mars_c.at(3)) - 0.20 * sin(earth_c.at(1) - mars_c.at(3))
		- 0.03 * sin(earth_c.at(2) - mars_c.at(2))
		+ 0.05 * cos(earth_c.at(2) - mars_c.at(3)) - 0.07 * sin(earth_c.at(2) - mars_c.at(3))
		- 0.10 * cos(earth_c.at(2) - mars_c.at(4)) + 0.11 * sin(earth_c.at(2) - mars_c.at(4))
		- 0.05 * cos(earth_c.at(3) - mars_c.at(5))
		+ 0.05 * cos(earth_c.at(3) - mars_c.at(6)) + 0.01 * sin(earth_c.at(3) - mars_c.at(6));
	return output;
}

double Sun::DILong_JS()
{
	std::vector<double> earth_c{ 2 * m_M.at(1), 3 * m_M.at(1) };
	std::vector<double> jupiter_c{ 2 * m_M.at(3), 3 * m_M.at(3), 4 * m_M.at(3) };
	double saturn_c = 2 * m_M.at(4);

	double output = +0.01 * cos(-m_M.at(1) - m_M.at(3)) + 0.07 * sin(-m_M.at(1) - m_M.at(3))
		- 0.31 * cos(-m_M.at(3)) + 2.58 * sin(-m_M.at(3))
		- 7.21 * cos(m_M.at(1) - m_M.at(3)) - 0.06 * sin(m_M.at(1) - m_M.at(3))
		- 0.54 * cos(m_M.at(1) - jupiter_c.at(0)) - 1.52 * sin(m_M.at(1) - jupiter_c.at(0))
		- 0.03 * cos(m_M.at(1) - jupiter_c.at(1)) - 0.21 * sin(m_M.at(1) - jupiter_c.at(1))
		- 0.16 * cos(earth_c.at(0) - m_M.at(3)) + 0.05 * sin(earth_c.at(0) - m_M.at(3))
		+ 0.14 * cos(earth_c.at(0) - jupiter_c.at(0)) - 2.73 * sin(earth_c.at(0) - jupiter_c.at(0))
		+ 0.07 * cos(earth_c.at(0) - jupiter_c.at(1)) - 0.55 * sin(earth_c.at(0) - jupiter_c.at(1))
		+ 0.02 * cos(earth_c.at(0) - jupiter_c.at(2)) - 0.08 * sin(earth_c.at(0) - jupiter_c.at(2))
		+ 0.01 * cos(earth_c.at(1) - jupiter_c.at(0)) - 0.07 * sin(earth_c.at(1) - jupiter_c.at(0))
		- 0.16 * cos(earth_c.at(1) - jupiter_c.at(1)) - 0.03 * sin(earth_c.at(1) - jupiter_c.at(1))
		- 0.04 * cos(earth_c.at(1) - jupiter_c.at(2)) - 0.01 * sin(earth_c.at(1) - jupiter_c.at(2))
		+ 0.32 * sin(-m_M.at(4))
		- 0.08 * cos(m_M.at(1) - m_M.at(4)) - 0.41 * sin(m_M.at(1) - m_M.at(4))
		+ 0.04 * cos(m_M.at(1) - saturn_c) + 0.10 * sin(m_M.at(1) - saturn_c)
		+ 0.04 * cos(earth_c.at(0) - saturn_c) + 0.10 * sin(earth_c.at(0) - saturn_c);
	return output;
}

double Sun::DILat()
{
	std::vector<double>	venus_c{ 2 * m_M.at(0), 3 * m_M.at(0), 4 * m_M.at(0), 5 * m_M.at(0) };
	std::vector<double> earth_c{ 2 * m_M.at(1), 3 * m_M.at(1), 4 * m_M.at(1),  5 * m_M.at(1) , 6 * m_M.at(1) , 7 * m_M.at(1) };
	std::vector<double> jupiter_c{ 2 * m_M.at(3), 3 * m_M.at(3), 4 * m_M.at(3) };

	double output = +0.02 * cos(-m_M.at(0)) - 0.02 * sin(-m_M.at(0))
		+ 0.02 * cos(m_M.at(1) - venus_c.at(0))
		+ 0.01 * cos(earth_c.at(0) - m_M.at(0)) - 0.09 * sin(earth_c.at(0) - m_M.at(0))
		+ 0.01 * cos(earth_c.at(0) - venus_c.at(0)) - 0.01 * sin(earth_c.at(0) - venus_c.at(0))
		+ 0.04 * cos(earth_c.at(1) - venus_c.at(0)) - 0.06 * sin(earth_c.at(1) - venus_c.at(0))
		+ 0.01 * cos(earth_c.at(1) - venus_c.at(1))
		+ 0.01 * cos(earth_c.at(2) - venus_c.at(0)) - 0.01 * sin(earth_c.at(2) - venus_c.at(0))
		+ 0.18 * cos(earth_c.at(2) - venus_c.at(1)) - 0.10 * sin(earth_c.at(2) - venus_c.at(1))
		+ 0.01 * cos(earth_c.at(3) - venus_c.at(1))
		- 0.03 * cos(earth_c.at(3) - venus_c.at(2))
		+ 0.01 * cos(earth_c.at(4) - venus_c.at(2))
		- 0.01 * cos(earth_c.at(4) - venus_c.at(3))
		- 0.02 * cos(earth_c.at(5) - venus_c.at(3)) - 0.01 * sin(earth_c.at(5) - venus_c.at(3))
		+ 0.01 * sin(earth_c.at(0) - 2 * m_M.at(2))
		+ 0.01 * cos(earth_c.at(1) - 4 * m_M.at(2))
		- 0.02 * sin(-m_M.at(1) - m_M.at(3))
		+ 0.02 * cos(-m_M.at(3))
		- 0.02 * sin(m_M.at(1) - m_M.at(3))
		+ 0.01 * cos(m_M.at(1) - jupiter_c.at(0)) - 0.17 * sin(m_M.at(1) - jupiter_c.at(0))
		- 0.02 * sin(m_M.at(1) - jupiter_c.at(1))
		+ 0.01 * cos(earth_c.at(0) - m_M.at(3))
		+ 0.01 * cos(earth_c.at(0) - jupiter_c.at(1))
		- 0.01 * sin(m_M.at(1) - m_M.at(4));

	return output;
}

double Sun::DIR_V()
{
	std::vector<double> earth_c{ 2 * m_M.at(1), 3 * m_M.at(1), 4 * m_M.at(1), 5 * m_M.at(1), 6 * m_M.at(1), 7 * m_M.at(1) };
	std::vector<double>	venus_c{ 2 * m_M.at(0), 3 * m_M.at(0), 4 * m_M.at(0), 5 * m_M.at(0), 6 * m_M.at(0) };

	double output = -16707.37 * cos(m_M.at(1)) - 0.54 * sin(m_M.at(1))
		+ (+42.04 * cos(m_M.at(1)) - 0.15 * sin(m_M.at(1))) * m_ts
		+ (+0.13 * cos(m_M.at(1)) - 0.02 * sin(m_M.at(1))) * m_ts * m_ts
		- 139.57 * cos(earth_c.at(0)) + 0.70 * cos(earth_c.at(0)) * m_ts
		- 1.75 * cos(earth_c.at(1)) - 0.16 * cos(-m_M.at(0)) - 0.07 * sin(-m_M.at(0))
		- 4.75 * cos(m_M.at(1) - m_M.at(0)) - 2.64 * sin(m_M.at(1) - m_M.at(0))
		+ 0.12 * cos(m_M.at(1) - 2 * m_M.at(0)) + 0.20 * sin(m_M.at(1) - 2 * m_M.at(0))
		+ 0.20 * cos(earth_c.at(0) - m_M.at(0)) - 0.01 * sin(earth_c.at(0) - m_M.at(0))
		+ 8.28 * cos(earth_c.at(0) - 2 * m_M.at(0)) + 13.42 * sin(earth_c.at(0) - 2 * m_M.at(0))
		- 1.44 * cos(earth_c.at(1) - 2 * m_M.at(0)) - 1.57 * sin(earth_c.at(1) - 2 * m_M.at(0))
		+ 0.11 * cos(earth_c.at(1) - 3 * m_M.at(0)) + 2.43 * sin(earth_c.at(1) - 3 * m_M.at(0))
		+ 0.10 * cos(earth_c.at(2) - 2 * m_M.at(0)) + 0.09 * sin(earth_c.at(2) - 2 * m_M.at(0))
		- 0.88 * cos(earth_c.at(2) - 3 * m_M.at(0)) - 3.36 * sin(earth_c.at(2) - 3 * m_M.at(0))
		- 0.38 * cos(earth_c.at(2) - 4 * m_M.at(0)) + 0.77 * sin(earth_c.at(2) - 4 * m_M.at(0))
		+ 0.30 * cos(earth_c.at(3) - 3 * m_M.at(0)) + 0.37 * sin(earth_c.at(3) - 3 * m_M.at(0))
		- 0.11 * cos(earth_c.at(3) - 4 * m_M.at(0)) + 0.43 * sin(earth_c.at(3) - 4 * m_M.at(0))
		- 0.31 * cos(earth_c.at(3) - 5 * m_M.at(0)) + 0.21 * sin(earth_c.at(3) - 5 * m_M.at(0))
		- 0.06 * cos(earth_c.at(4) - 4 * m_M.at(0)) - 0.21 * sin(earth_c.at(4) - 4 * m_M.at(0))
		- 0.09 * cos(earth_c.at(4) - 5 * m_M.at(0)) + 0.09 * sin(earth_c.at(4) - 5 * m_M.at(0))
		- 0.18 * cos(earth_c.at(4) - 6 * m_M.at(0)) + 0.02 * sin(earth_c.at(4) - 6 * m_M.at(0))
		- 0.08 * cos(earth_c.at(5) - 5 * m_M.at(0)) + 0.31 * sin(earth_c.at(5) - 5 * m_M.at(0));
	return output;
}

double Sun::DIR_M() {
	std::vector<double> earth_c{ 2 * m_M.at(1), 3 * m_M.at(1), 4 * m_M.at(1), 5 * m_M.at(1) };
	std::vector<double> mars_c{ 2 * m_M.at(2), 3 * m_M.at(2),  4 * m_M.at(2) ,5 * m_M.at(2) , 6 * m_M.at(2) , 7 * m_M.at(2), 8 * m_M.at(2) };

	double output = -0.21 * cos(m_M.at(1) - m_M.at(2)) - 0.27 * sin(m_M.at(1) - m_M.at(2))
		+ 0.16 * cos(m_M.at(1) - mars_c.at(0)) + 0.28 * sin(m_M.at(1) - mars_c.at(0))
		- 1.32 * cos(earth_c.at(0) - mars_c.at(0)) + 4.55 * sin(earth_c.at(0) - mars_c.at(0))
		- 0.17 * cos(earth_c.at(0) - mars_c.at(1)) + 0.46 * sin(earth_c.at(0) - mars_c.at(1))
		+ 0.09 * cos(earth_c.at(0) - mars_c.at(2)) - 0.22 * sin(earth_c.at(0) - mars_c.at(2))
		- 0.35 * cos(earth_c.at(1) - mars_c.at(1)) + 0.15 * sin(earth_c.at(1) - mars_c.at(1))
		+ 1.06 * cos(earth_c.at(1) - mars_c.at(2)) - 0.29 * sin(earth_c.at(1) - mars_c.at(2))
		+ 0.20 * cos(earth_c.at(1) - mars_c.at(3)) - 0.04 * sin(earth_c.at(1) - mars_c.at(3))
		+ 0.10 * cos(earth_c.at(2) - mars_c.at(2)) + 0.04 * sin(earth_c.at(2) - mars_c.at(2))
		+ 0.20 * cos(earth_c.at(2) - mars_c.at(3)) + 0.14 * sin(earth_c.at(2) - mars_c.at(3))
		- 0.23 * cos(earth_c.at(2) - mars_c.at(4)) - 0.22 * sin(earth_c.at(2) - mars_c.at(4))
		+ 0.01 * cos(earth_c.at(3) - mars_c.at(5)) - 0.14 * sin(earth_c.at(3) - mars_c.at(5))
		- 0.02 * cos(earth_c.at(3) - mars_c.at(6)) + 0.10 * sin(earth_c.at(3) - mars_c.at(6));
	return output;
}

double Sun::DIR_JS() {
	std::vector<double> earth_c{ 2 * m_M.at(1), 3 * m_M.at(1) };
	std::vector<double> jupiter_c{ 2 * m_M.at(3), 3 * m_M.at(3), 4 * m_M.at(3) };
	double saturn_c = 2 * m_M.at(4);

	double output = +0.18 * cos(-m_M.at(1) - m_M.at(3)) - 0.02 * sin(-m_M.at(1) - m_M.at(3))
		+ 0.52 * cos(-m_M.at(3)) + 0.34 * sin(-m_M.at(3))
		+ 0.13 * cos(m_M.at(1) - m_M.at(3)) - 16.27 * sin(m_M.at(1) - m_M.at(3))
		+ 3.09 * cos(m_M.at(1) - jupiter_c.at(0)) - 1.12 * sin(m_M.at(1) - jupiter_c.at(0))
		+ 0.38 * cos(m_M.at(1) - jupiter_c.at(1)) - 0.06 * sin(m_M.at(1) - jupiter_c.at(1))
		- 0.18 * cos(earth_c.at(0) - m_M.at(3)) - 0.31 * sin(earth_c.at(0) - m_M.at(3))
		+ 9.23 * cos(earth_c.at(0) - jupiter_c.at(0)) + 0.48 * sin(earth_c.at(0) - jupiter_c.at(0))
		+ 1.83 * cos(earth_c.at(0) - jupiter_c.at(1)) + 0.25 * sin(earth_c.at(0) - jupiter_c.at(1))
		+ 0.25 * cos(earth_c.at(0) - jupiter_c.at(2)) + 0.06 * sin(earth_c.at(0) - jupiter_c.at(2))
		+ 0.16 * cos(earth_c.at(1) - jupiter_c.at(0)) + 0.04 * sin(earth_c.at(1) - jupiter_c.at(0))
		+ 0.08 * cos(earth_c.at(1) - jupiter_c.at(1)) - 0.64 * sin(earth_c.at(1) - jupiter_c.at(1))
		+ 0.03 * cos(earth_c.at(1) - jupiter_c.at(2)) - 0.17 * sin(earth_c.at(1) - jupiter_c.at(2))
		+ 0.01 * cos(-m_M.at(4))
		+ 0.97 * cos(m_M.at(1) - m_M.at(4)) - 0.18 * sin(m_M.at(1) - m_M.at(4))
		- 0.23 * cos(m_M.at(1) - saturn_c) + 0.10 * sin(m_M.at(1) - saturn_c)
		- 0.35 * cos(earth_c.at(0) - saturn_c) + 0.13 * sin(earth_c.at(0) - saturn_c);
	return output;
}

int Sun::calculateRs()
{
	m_Rs = sqrt(pow(m_DC(0, 0), 2) + pow(m_DC(1, 0), 2) + pow(m_DC(2, 0), 2));
	return 0;
}

int Sun::calculateRo(const Matrix& DC_coord_object)
{
	m_Ro = sqrt(pow(m_DC(0, 0) - DC_coord_object(0, 0), 2) +
		pow(m_DC(1, 0) - DC_coord_object(1, 0), 2) +
		pow(m_DC(2, 0), 2) - DC_coord_object(2, 0));
	return 0;
}

Matrix& Sun::calculateFs(const Matrix& DC_coord_object, double input_MJD)
{
	calculateGEC(input_MJD);
	calculateRs();
	calculateRo(DC_coord_object);
	m_F(0, 0) = gravitational_parameter_Sun * (((m_DC(0, 0) - DC_coord_object(0, 0)) / pow(m_Ro, 3)) - (m_DC(0, 0) / pow(m_Rs, 3)));
	m_F(1, 0) = gravitational_parameter_Sun * (((m_DC(1, 0) - DC_coord_object(1, 0)) / pow(m_Ro, 3)) - (m_DC(1, 0) / pow(m_Rs, 3)));
	m_F(2, 0) = gravitational_parameter_Sun * (((m_DC(2, 0) - DC_coord_object(2, 0)) / pow(m_Ro, 3)) - (m_DC(2, 0) / pow(m_Rs, 3)));
	return m_F;
}

Matrix& Sun::calculatePs(const Matrix& DC_coord_object, const satellite_parameters& i_param, double input_MJD)
{
	calculateGEC(input_MJD);
	calculateRs();
	calculateRo(DC_coord_object);
	double C = (0.001 * light_pressure * i_param.reflection_coefficient * (i_param.cross_sectional_radius / i_param.mass)) 
		* pow(((1.4959787 * pow(10, 8)) / m_Ro), 2);

	m_P(0, 0) = C * ((DC_coord_object(0,0) - m_DC(0, 0))/ m_Ro);
	m_P(1, 0) = C * ((DC_coord_object(1, 0) - m_DC(0, 0)) / m_Ro);
	m_P(2, 0) = C * ((DC_coord_object(2, 0) - m_DC(2, 0)) / m_Ro);
	return m_P;
}

int Sun::calculateAverageAnomalies()
{
	m_M.at(0) = 0.87167007 + 1021.32292307 * m_ts;
	m_M.at(1) = 6.23999846 + 628.30194562 * m_ts;
	m_M.at(2) = 0.34133404 + 334.05561755 * m_ts;
	m_M.at(3) = 0.34667475 + 52.96346464 * m_ts;
	m_M.at(4) = 5.53957033 + 21.32432794 * m_ts;
	m_fa.D = 5.19870752 + 7771.37722506 * m_ts;
	m_fa.l = 2.35556617 + 8328.69136358 * m_ts;
	m_fa.F = 1.62797331 + 8433.46599185 * m_ts;
	return 0;
}

int Sun::calculatePerturbation()
{
	m_perturbation(0, 0) = DILong_V() + DILong_M() + DILong_JS() + 6.4 * sin(m_fa.D) - 0.42 * sin(m_fa.D - m_fa.l)
		+ 0.18 * sin(m_fa.D + m_fa.l) + 0.17 * sin(m_fa.D - m_M.at(1)) - 0.06 * sin(m_fa.D + m_M.at(1))
		+ 6.40 * sin(4.38754830 + 0.35248670 * m_ts) + 1.87 * sin(3.62162801 + 2.62260155 * m_ts)
		+ 0.27 * sin(2.63202633 + 2.07722106 * m_ts) + 0.20 * sin(2.25000866 + 15.59109602 * m_ts);

	m_perturbation(1, 0) = DILat() + 0.576 * sin(m_fa.F);

	m_perturbation(2, 0) = DIR_V() + DIR_M() + DIR_JS() + 30.76 * cos(m_fa.D) - 3.06 * cos(m_fa.D - m_fa.l)
		+ 0.85 * cos(m_fa.D + m_fa.l) - 0.58 * cos(m_fa.D + m_M.at(1)) + 0.57 * cos(m_fa.D - m_M.at(1));
	return 0;
}

int Sun::calculateGEC(double input_MJD)
{
	recalc(_MJDt.convert_MJD_to_TDB(input_MJD));
	calculateAverageAnomalies();
	calculatePerturbation();
	m_GEC(0, 0) = 4.93823996 + m_M.at(1) + RS * ((6191.2 + 1.1 * m_ts) * m_ts + m_perturbation(0, 0));
	m_GEC(1, 0) = RS * m_perturbation(1, 0);
	m_GEC(2, 0) = AU * (1.0001398 - 0.0000007 * m_ts + pow(10, -6) * m_perturbation(2, 0));
	calculateDC();
	return 0;
}

Sun::Sun(double input_MJD) : ConvertSC{ _MJDt.convert_MJD_to_TDB(input_MJD) }{
		DILong_V();
		DILong_M();
		DILong_JS();
		DILat();
		DIR_V();
		DIR_M();
		DIR_JS();
		calculateRs();
		calculateAverageAnomalies();
		calculatePerturbation();
};

Matrix Earth::fill_matrix(const char fileName[])
{
	std::ifstream fin(fileName);
	if (!fin.is_open()) {
		assert("dont open file");
		std::cout << "failed open the file";
		exit(10000);
	}

	std::string buff;
	std::string buff1;
	std::getline(fin, buff);
	std::istringstream str(buff);
	uint32_t rows = 0;
	uint32_t cols = 0;
	
	str >> buff1;
	rows = stoi(buff1);
	
	str >> buff1;
	cols = stoi(buff1);
	
	m_rows = (rows >= cols) ? rows : cols;
	m_cols = (rows >= cols) ? rows : cols;
	Matrix output{ m_rows, m_cols};
	rows = 0; 
	cols = 2;

	while (!fin.eof()) {
		std::getline(fin, buff);
		str = std::istringstream(buff);
		while (!str.eof()) {
			str >> buff1;
			output(rows, cols) = stod(buff1);
			cols++;
		}
		cols = 2;
		rows++;
	}

	fin.close();
	return output;
}

int Earth::setF()
{
	for(short i = 0; i < 3; i ++)
		m_F(i, 0) = -gravitational_parameter_Earth * (m_GDC(i, 0) / (pow(m_r, 3)));
	return 0;
}

int Earth::setRatio()
{
	m_ratio.Rr = Radius_Earth / m_r;
	m_ratio.Xr = m_GEC(0, 0) / m_r;
	m_ratio.Yr = m_GEC(1, 0) / m_r;
	m_ratio.Zr = m_GEC(2, 0) / m_r;
	return 0;
}

int Earth::calculatePartialDeriv()
{
	//вычисление частных производных по x
	PartialDeriv(0, 0) = -(m_GDC(0, 0)) / pow(m_r, 3);
	PartialDeriv(1, 0) = (1 / m_r) - pow(m_GDC(0, 0), 2) / pow(m_r, 3);
	PartialDeriv(2, 0) = -(m_GDC(0, 0) * m_GDC(1, 0)) / pow(m_r, 3);
	PartialDeriv(3, 0) = -(m_GDC(0, 0) * m_GDC(2, 0)) / pow(m_r, 3);

	//вычисление частныхм производных по y
	PartialDeriv(0, 1) = -(m_GDC(1, 0)) / pow(m_r, 3);
	PartialDeriv(1, 1) = -(m_GDC(0, 0) * m_GDC(1, 0)) / pow(m_r, 3);
	PartialDeriv(2, 1) = (1 / m_r) - pow(m_GDC(1, 0), 2) / pow(m_r, 3);
	PartialDeriv(3, 1) = -(m_GDC(1, 0) * m_GDC(2, 0)) / pow(m_r, 3);

	//вычисление частных производных по z
	PartialDeriv(0, 1) = -(m_GDC(2, 0)) / pow(m_r, 3);
	PartialDeriv(1, 1) = -(m_GDC(0, 0) * m_GDC(2, 0)) / pow(m_r, 3);
	PartialDeriv(2, 1) = -(m_GDC(1, 0) * m_GDC(2, 0)) / pow(m_r, 3);
	PartialDeriv(3, 1) = (1 / m_r) - pow(m_GDC(2, 0), 2) / pow(m_r, 3);
	return 0;
}

int Earth::calculateStartParameters()
{
	m_R(0, 2) = (gravitational_parameter_Earth / m_r) * pow(m_ratio.Rr, 2);
	m_Partial_R(0, 2) = 3 * gravitational_parameter_Earth * pow(m_ratio.Rr, 2);
	m_Z(0, 1) = m_ratio.Zr;
	m_Z(0, 2) = (3 / 2) * pow(m_ratio.Zr, 2) - (1 / 2);
	m_Partial_Z(0, 1) = 1;
	m_Partial_Z(0, 2) = 3 * m_ratio.Zr;
	m_X(0, 0) = 1;
	m_Y(0, 0) = 0;
	return 0;
}

int Earth::calculateAccelerationByEarth()
{
	calculatePartialDeriv();
	calculateStartParameters();
	setRatio();
	setF();
	calculateRn();
	calculatePartialRn();
	calculateZn0();
	calculatePartialZn0();
	
	for (int k = 1; k < m_rows; k++) {
		calculateZn_k(k);
		calculatePartialZn_k(k);
		calculateXY_k(k);
		claculatePartialXxy_k(k);
		claculatePartialYxy_k(k);
		calculateQn_k(k);
		calculatePartialQn_k(k);
		calculateF(k);
	}
	return 0;
}

int Earth::calculateERM(double input_MJD)
{
	double GTST{_MJDt.convert_MJD_to_GTST(input_MJD)};
	m_ERM = Earth_rot_matrix(GTST);
	return 0;
}

Earth::Earth(double input_MJD, Matrix input_GCC) : ConvertSC{ _MJDt.convert_MJD_to_TDB(input_MJD) }
{
	calculateERM(input_MJD);
	m_GDC = CC_to_TC(m_precession, m_nutation, m_ERM) * input_GCC;
	calculate_r();
	calculateAccelerationByEarth();
	Matrix m_CC_to_TC{ CC_to_TC(m_precession, m_nutation, m_ERM) };
	m_FCS = TC_to_CC(m_CC_to_TC) * m_F;
}

Earth Earth::operator=(const Earth& input)
{
	if (this == &input) return *this;

	this->Δψ = input.Δψ;
	this->m_ε = input.m_ε;
	this-> Δψ = input.Δψ;
	this->Δε = input.Δε;
	this->m_t = input.m_t;
	this->m_ts = input.m_ts;
	this->m_precession = input.m_precession;
	this->m_nutation = input.m_nutation;
	this->m_GEC = input.m_GEC;
	this->m_DC = input.m_DC;
	this->m_pp = input.m_pp;
	this->m_fa = input.m_fa;


	this->m_r = input.m_r;
	this->m_h = input.m_h; 
	this->m_ratio = input.m_ratio;
	this->m_u = input.m_u;
	this->m_cols = input.m_cols; 
	this->m_rows = input.m_rows; 
	this->m_ERM = input.m_ERM; 

	this->coefficient_С = input.coefficient_С;
	this->coefficient_S = input.coefficient_S;
	this->m_GDC = input.m_GDC;
	this->PartialDeriv = input.PartialDeriv;
	this->m_R = input.m_R;
	this->m_Partial_R = input.m_Partial_R;
	this->m_Z = input.m_Z;
	this->m_Partial_Z = input.m_Partial_Z;
	this->m_X = input.m_X;
	this->m_Y = input.m_Y;
	this->m_Partial_Xx = input.m_Partial_Xx;
	this->m_Partial_Xy = input.m_Partial_Xy;
	this->m_Partial_Yx = input.m_Partial_Yx;
	this->m_Partial_Yy = input.m_Partial_Yy;
	this->m_Q = input.m_Q;
	this->m_Partial_Qx = input.m_Partial_Qx;
	this->m_Partial_Qy = input.m_Partial_Qy;
	this->m_F = input.m_F;
	this->m_FCS = input.m_FCS;
	
	return *this;
}

int Earth::calculateRn()
{
	for (int i = 3; i < m_cols; i++)
		m_R(0, i) = m_ratio.Rr * m_R(0, i - 1);
	return 0;
}

int Earth::calculatePartialRn()
{
	for (int i = 3; i < m_cols; i++)
		m_Partial_R(0, i) = (i + 1) * gravitational_parameter_Earth * pow(m_ratio.Rr, i);
	return 0;
}

int Earth::calculateZn0()
{
	for (int i = 3; i < m_cols; i++)
		m_Z(0, i) = (double(2 * i - 1) / i) * m_ratio.Zr * m_Z(0, i - 1) - (double(i - 1) / i) * m_Z(0, i - 2);
	return 0;
}

int Earth::calculatePartialZn0()
{
	for (int i = 3; i < m_cols; i++)
		m_Partial_Z(0, i) = i * m_Z(0, i - 1) + m_ratio.Zr * m_Partial_Z(0, i - 1);
	return 0;
}

int Earth::calculateZn_k(int k)
{
	for (int i = 2; i < m_cols; i++)
		m_Z(k, i) = m_Partial_Z(k - 1, i);
	return 0;
}

int Earth::calculatePartialZn_k(int k)
{
	for (int i = 0; i <= k; i++)
		m_Partial_Z(k, i) = 0;
	for (int i = k + 1; i < m_cols; i++)
		m_Partial_Z(k, i) = (2 * i - 1) * m_Z(k, i - 1) + m_Partial_Z(k, i - 2);
	return 0;
}

int Earth::calculateXY_k(int k)
{
	m_X(k, 0) = m_X(k - 1, 0) * m_ratio.Xr - m_Y(k - 1, 0) * m_ratio.Yr;
	m_Y(k, 0) = m_Y(k - 1, 0) * m_ratio.Xr + m_X(k - 1, 0) * m_ratio.Yr;
	return 0;
}

int Earth::claculatePartialXxy_k(int k)
{
	m_Partial_Xx(k, 0) = m_Partial_Xx(k - 1, 0) * m_ratio.Xr + m_X(k - 1, 0) - m_Partial_Yx(k - 1, 0) * m_ratio.Yr;
	m_Partial_Xy(k, 0) = m_Partial_Xy(k - 1, 0) * m_ratio.Xr - m_Partial_Yy(k - 1, 0) * m_ratio.Yr - m_Y(k-1, 0);
	return 0;
}

int Earth::claculatePartialYxy_k(int k) {
	m_Partial_Yx(k, 0) = m_Partial_Yx(k - 1, 0) * m_ratio.Xr + m_Y(k - 1, 0) - m_Partial_Xx(k - 1, 0) * m_ratio.Yr;
	m_Partial_Yy(k, 0) = m_Partial_Yy(k - 1, 0) * m_ratio.Xr + m_Partial_Xy(k - 1, 0) * m_ratio.Yr + m_X(k - 1, 0);
	return 0;
}

int Earth::calculateQn_k(int i_k)
{
	int i = (i_k > 2) ? i_k : 2;
	for (; i < m_cols; i++)
		m_Q(i_k, i) = coefficient_С(i_k, i) * m_X(i_k, 0) + coefficient_S(i_k, i) * m_Y(i_k, 0);
	return 0;
}

int Earth::calculate_r()
{
	m_r = sqrt(pow(m_GDC(0, 0), 2) + pow(m_GDC(1, 0), 2) + pow(m_GDC(2, 0), 2));
	return 0;
}

int Earth::calculatePartialQn_k(int i_k)
{
	int i = (i_k > 2) ? i_k : 2;
	for (; i < m_cols; i++) {
		m_Partial_Qx(i_k, i) = coefficient_С(i_k, i) * m_Partial_Xx(i_k, 0) + coefficient_S(i_k, i) * m_Partial_Yx(i_k, 0);
		m_Partial_Qy(i_k, i) = coefficient_С(i_k, i) * m_Partial_Xy(i_k, 0) + coefficient_S(i_k, i) * m_Partial_Yy(i_k, 0);
	}
	return 0;
}

int Earth::calcuclateUkn(int k, int n)
{	
	m_u.x = m_Partial_R(0, n) * PartialDeriv(0, 0) * m_Z(k, n) * m_Q(k, n) 
		+ m_R(0, 1) * m_Partial_Z(k, n) * PartialDeriv(3, 0) * m_Q(k, n)
		+ m_R(0, 1) * m_Z(k, n) * (m_Partial_Qx(k, n) * PartialDeriv(1, 0) + m_Partial_Qy(k, n) * PartialDeriv(2, 0));
	m_u.y = m_Partial_R(0, n) * PartialDeriv(0, 1) * m_Z(k, n) * m_Q(k, n) 
		+ m_R(0, n) * m_Partial_Z(k, n) * PartialDeriv(3, 1) * m_Q(k, n)
		+ m_R(0, n) * m_Z(k, n) * (m_Partial_Qx(k, n) * PartialDeriv(1, 1) + m_Partial_Qy(k, n) * PartialDeriv(2, 1));

	m_u.y = m_Partial_R(0, n) * PartialDeriv(0, 2) * m_Z(k, n) * m_Q(k, n)
		+ m_R(0, n) * m_Partial_Z(k, n) * PartialDeriv(3, 2) * m_Q(k, n)
		+ m_R(0, n) * m_Z(k, n) * (m_Partial_Qx(k, n) * PartialDeriv(1, 2) + m_Partial_Qy(k, n) * PartialDeriv(2, 2));
	return 0;
}

int Earth::calculateF(int k) {
	double SumX = 0, SumY = 0, SumZ = 0;
	for (int i = k; i < m_cols; i++) {
		calcuclateUkn(k, i);
		SumX += m_u.x;
		SumY += m_u.x;
		SumZ += m_u.x;
	}
	m_F(0, 0) += SumX;
	m_F(1, 0) += SumY;
	m_F(2, 0) += SumZ;
	return 0;
}