#include "Shader.h"
Shader::Shader(const GLchar* vertexPath, const GLchar* fragmentPath)
{

	/* ***            *** */
	std::string vertexCode; //     Vertex
	std::string fragmentCode; //     Fragment
	//        ASCII
	std::ifstream vShaderFile;
	std::ifstream fshaderFile;
	//    , 
	vShaderFile.exceptions(std::ifstream::failbit | std::ifstream::badbit);
	fshaderFile.exceptions(std::ifstream::failbit | std::ifstream::badbit);
	try {
		std::stringstream vShaderStream, fShaderStream; //     
		// 
		vShaderFile.open(vertexPath);
		fshaderFile.open(fragmentPath);
		//
		vShaderStream << vShaderFile.rdbuf();
		fShaderStream << fshaderFile.rdbuf();
		// 
		vShaderFile.close();
		fshaderFile.close();
		//    string
		vertexCode = vShaderStream.str();
		fragmentCode = fShaderStream.str();
	}
	catch (std::ifstream::failure e) {
		std::cerr << "Exception opening/reading/closing file\n";
		std::cout << "Exception opening/reading/closing file\n";
	}
	//     GLchar
	const GLchar* vShaderCode = vertexCode.c_str();
	const GLchar* fShaderCode = fragmentCode.c_str();

	/* ***   *** */
	GLuint vertex, fragment;
	GLint success;
	GLchar infoLog[512];

	// 
	vertex = glCreateShader(GL_VERTEX_SHADER);
	glShaderSource(vertex, 1, &vShaderCode, NULL);
	glCompileShader(vertex);
	//   
	glGetShaderiv(vertex, GL_COMPILE_STATUS, &success);
	if (!success) {
		glGetShaderInfoLog(vertex, 512, NULL, infoLog);
		std::cout << "ERROR:Shader:vertex:Compilation_Filed\n" << infoLog << std::endl;
	}

	// 
	fragment = glCreateShader(GL_FRAGMENT_SHADER);
	glShaderSource(fragment, 1, &fShaderCode, NULL);
	glCompileShader(fragment);
	//  
	glGetShaderiv(fragment, GL_COMPILE_STATUS, &success);
	if (!success) {
		glGetShaderInfoLog(fragment, 512, NULL, infoLog);
		std::cout << "ERROR:Shader:fragment:Compilation_Filed\n" << infoLog << std::endl;
	}

	// 
	Id = glCreateProgram();
	glAttachShader(Id, vertex);
	glAttachShader(Id, fragment);
	glLinkProgram(Id);
	//  
	glGetProgramiv(Id, GL_LINK_STATUS, &success);
	if (!success) {
		glGetProgramInfoLog(Id, 512, NULL, infoLog);
		std::cout << "ERROR:Shader:Id:CreateProgrammFiled\n" << infoLog << std::endl;
	}
	// 
	glDeleteShader(vertex);
	glDeleteShader(fragment);
}